/* VpnInterface.c generated by valac 0.56.1, the Vala compiler
 * generated from VpnInterface.vala, do not modify */

/*
 * Copyright 2017-2021 elementary, Inc. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "network.h"
#include <NetworkManager.h>
#include <gtk/gtk.h>
#include <granite.h>
#include <glib.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>

enum  {
	NETWORK_VPN_INTERFACE_0_PROPERTY,
	NETWORK_VPN_INTERFACE_VPN_STATE_PROPERTY,
	NETWORK_VPN_INTERFACE_NM_CLIENT_PROPERTY,
	NETWORK_VPN_INTERFACE_NUM_PROPERTIES
};
static GParamSpec* network_vpn_interface_properties[NETWORK_VPN_INTERFACE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _NetworkVpnInterfacePrivate {
	NetworkState _vpn_state;
	NMClient* _nm_client;
	NMVpnConnection* active_vpn_connection;
	GtkListBox* vpn_list;
	NetworkVpnMenuItem* active_vpn_item;
	NetworkVpnMenuItem* blank_item;
	GraniteSwitchModelButton* vpn_item;
	GtkRevealer* revealer;
};

static gint NetworkVpnInterface_private_offset;
static gpointer network_vpn_interface_parent_class = NULL;

static void network_vpn_interface_real_update_name (NetworkWidgetNMInterface* base,
                                             gint count);
static void network_vpn_interface_real_update (NetworkWidgetNMInterface* base);
static void network_vpn_interface_update_active_connection (NetworkVpnInterface* self);
static void network_vpn_interface_set_vpn_state (NetworkVpnInterface* self,
                                          NetworkState value);
static NetworkVpnMenuItem* network_vpn_interface_get_item_by_uuid (NetworkVpnInterface* self,
                                                            const gchar* uuid);
static void network_vpn_interface_check_vpn_availability (NetworkVpnInterface* self);
static void network_vpn_interface_show_vpn (NetworkVpnInterface* self,
                                     gboolean show);
static void network_vpn_interface_vpn_activate_cb (NetworkVpnInterface* self,
                                            NetworkVpnMenuItem* item);
static void network_vpn_interface_vpn_deactivate_cb (NetworkVpnInterface* self);
static gboolean __lambda22_ (NetworkVpnInterface* self);
static gboolean ___lambda22__gsource_func (gpointer self);
static gboolean __lambda21_ (NetworkVpnInterface* self);
static gboolean ___lambda21__gsource_func (gpointer self);
static void network_vpn_interface_vpn_added_cb (NetworkVpnInterface* self,
                                         GObject* obj);
static void _network_vpn_interface_vpn_activate_cb_network_vpn_menu_item_user_action (NetworkVpnMenuItem* _sender,
                                                                               gpointer self);
static void network_vpn_interface_vpn_removed_cb (NetworkVpnInterface* self,
                                           NMRemoteConnection* vpn_);
static void __lambda20_ (NetworkVpnInterface* self,
                  NMActiveConnection* ac);
static void _network_widget_nm_interface_update_nm_vpn_connection_vpn_state_changed (NMVpnConnection* _sender,
                                                                              guint state,
                                                                              guint reason,
                                                                              gpointer self);
static void ___lambda20__gfunc (gconstpointer data,
                         gpointer self);
static GObject * network_vpn_interface_constructor (GType type,
                                             guint n_construct_properties,
                                             GObjectConstructParam * construct_properties);
static void _network_vpn_interface___lambda23_ (NetworkVpnInterface* self);
static void __network_vpn_interface___lambda23__g_object_notify (GObject* _sender,
                                                          GParamSpec* pspec,
                                                          gpointer self);
static void _network_widget_nm_interface_update_g_object_notify (GObject* _sender,
                                                          GParamSpec* pspec,
                                                          gpointer self);
static void _network_vpn_interface_check_vpn_availability_gtk_container_add (GtkContainer* _sender,
                                                                      GtkWidget* widget,
                                                                      gpointer self);
static void _network_vpn_interface_check_vpn_availability_gtk_container_remove (GtkContainer* _sender,
                                                                         GtkWidget* widget,
                                                                         gpointer self);
static void _network_vpn_interface_vpn_added_cb_nm_client_connection_added (NMClient* _sender,
                                                                     NMRemoteConnection* connection,
                                                                     gpointer self);
static void _network_vpn_interface_vpn_removed_cb_nm_client_connection_removed (NMClient* _sender,
                                                                         NMRemoteConnection* connection,
                                                                         gpointer self);
static void _network_vpn_interface___lambda24_ (NetworkVpnInterface* self,
                                         NMRemoteConnection* connection);
static void __network_vpn_interface___lambda24__gfunc (gconstpointer data,
                                                gpointer self);
static void network_vpn_interface_finalize (GObject * obj);
static GType network_vpn_interface_get_type_once (void);
static void _vala_network_vpn_interface_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec);
static void _vala_network_vpn_interface_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec);

static inline gpointer
network_vpn_interface_get_instance_private (NetworkVpnInterface* self)
{
	return G_STRUCT_MEMBER_P (self, NetworkVpnInterface_private_offset);
}

NetworkVpnInterface*
network_vpn_interface_construct (GType object_type,
                                 NMClient* nm_client)
{
	NetworkVpnInterface * self = NULL;
	g_return_val_if_fail (nm_client != NULL, NULL);
	self = (NetworkVpnInterface*) g_object_new (object_type, "nm-client", nm_client, NULL);
	return self;
}

NetworkVpnInterface*
network_vpn_interface_new (NMClient* nm_client)
{
	return network_vpn_interface_construct (NETWORK_TYPE_VPN_INTERFACE, nm_client);
}

static void
network_vpn_interface_real_update_name (NetworkWidgetNMInterface* base,
                                        gint count)
{
	NetworkVpnInterface * self;
	self = (NetworkVpnInterface*) base;
	network_widget_nm_interface_set_display_title ((NetworkWidgetNMInterface*) self, _ ("VPN"));
}

static void
network_vpn_interface_real_update (NetworkWidgetNMInterface* base)
{
	NetworkVpnInterface * self;
	NetworkVpnMenuItem* item = NULL;
	NMVpnConnection* _tmp0_;
	NetworkVpnMenuItem* _tmp10_;
	GraniteSwitchModelButton* _tmp17_;
	NetworkVpnMenuItem* _tmp18_;
	self = (NetworkVpnInterface*) base;
	network_vpn_interface_update_active_connection (self);
	item = NULL;
	_tmp0_ = self->priv->active_vpn_connection;
	if (_tmp0_ != NULL) {
		NMVpnConnection* _tmp1_;
		NMVpnConnectionState _tmp2_;
		NMVpnConnectionState _tmp3_;
		_tmp1_ = self->priv->active_vpn_connection;
		_tmp2_ = nm_vpn_connection_get_vpn_state (_tmp1_);
		_tmp3_ = _tmp2_;
		switch (_tmp3_) {
			case NM_VPN_CONNECTION_STATE_UNKNOWN:
			case NM_VPN_CONNECTION_STATE_DISCONNECTED:
			{
				network_vpn_interface_set_vpn_state (self, NETWORK_STATE_DISCONNECTED);
				_g_object_unref0 (self->priv->active_vpn_item);
				self->priv->active_vpn_item = NULL;
				break;
			}
			case NM_VPN_CONNECTION_STATE_PREPARE:
			case NM_VPN_CONNECTION_STATE_IP_CONFIG_GET:
			case NM_VPN_CONNECTION_STATE_CONNECT:
			{
				NMVpnConnection* _tmp4_;
				const gchar* _tmp5_;
				NetworkVpnMenuItem* _tmp6_;
				network_vpn_interface_set_vpn_state (self, NETWORK_STATE_CONNECTING_VPN);
				_tmp4_ = self->priv->active_vpn_connection;
				_tmp5_ = nm_active_connection_get_uuid ((NMActiveConnection*) _tmp4_);
				_tmp6_ = network_vpn_interface_get_item_by_uuid (self, _tmp5_);
				_g_object_unref0 (item);
				item = _tmp6_;
				break;
			}
			case NM_VPN_CONNECTION_STATE_FAILED:
			{
				network_vpn_interface_set_vpn_state (self, NETWORK_STATE_FAILED);
				_g_object_unref0 (self->priv->active_vpn_item);
				self->priv->active_vpn_item = NULL;
				break;
			}
			case NM_VPN_CONNECTION_STATE_ACTIVATED:
			{
				NMVpnConnection* _tmp7_;
				const gchar* _tmp8_;
				NetworkVpnMenuItem* _tmp9_;
				network_vpn_interface_set_vpn_state (self, NETWORK_STATE_CONNECTED_VPN);
				_tmp7_ = self->priv->active_vpn_connection;
				_tmp8_ = nm_active_connection_get_uuid ((NMActiveConnection*) _tmp7_);
				_tmp9_ = network_vpn_interface_get_item_by_uuid (self, _tmp8_);
				_g_object_unref0 (item);
				item = _tmp9_;
				gtk_widget_set_sensitive ((GtkWidget*) self, TRUE);
				break;
			}
			default:
			break;
		}
	} else {
		network_vpn_interface_set_vpn_state (self, NETWORK_STATE_DISCONNECTED);
	}
	_tmp10_ = item;
	if (_tmp10_ == NULL) {
		NetworkVpnMenuItem* _tmp11_;
		NetworkVpnMenuItem* _tmp12_;
		_tmp11_ = self->priv->blank_item;
		network_vpn_menu_item_set_active (_tmp11_, TRUE);
		_tmp12_ = self->priv->active_vpn_item;
		if (_tmp12_ != NULL) {
			NetworkVpnMenuItem* _tmp13_;
			NetworkVpnMenuItem* _tmp14_;
			NetworkVpnMenuItem* _tmp15_;
			NetworkState _tmp16_;
			_tmp13_ = self->priv->active_vpn_item;
			gtk_widget_set_no_show_all ((GtkWidget*) _tmp13_, FALSE);
			_tmp14_ = self->priv->active_vpn_item;
			gtk_widget_set_visible ((GtkWidget*) _tmp14_, TRUE);
			_tmp15_ = self->priv->active_vpn_item;
			_tmp16_ = self->priv->_vpn_state;
			network_vpn_menu_item_set_vpn_state (_tmp15_, _tmp16_);
		}
	}
	network_vpn_interface_check_vpn_availability (self);
	_tmp17_ = self->priv->vpn_item;
	_tmp18_ = self->priv->active_vpn_item;
	gtk_toggle_button_set_active ((GtkToggleButton*) _tmp17_, _tmp18_ != NULL);
	NETWORK_WIDGET_NM_INTERFACE_CLASS (network_vpn_interface_parent_class)->update (G_TYPE_CHECK_INSTANCE_CAST (self, NETWORK_TYPE_WIDGET_NM_INTERFACE, NetworkWidgetNMInterface));
	_g_object_unref0 (item);
}

static void
network_vpn_interface_check_vpn_availability (NetworkVpnInterface* self)
{
	guint length = 0U;
	GtkListBox* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
	guint _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->vpn_list;
	_tmp1_ = gtk_container_get_children ((GtkContainer*) _tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_list_length (_tmp2_);
	(_tmp2_ == NULL) ? NULL : (_tmp2_ = (g_list_free (_tmp2_), NULL));
	length = _tmp3_;
	network_vpn_interface_show_vpn (self, length > ((guint) 1));
}

static void
network_vpn_interface_show_vpn (NetworkVpnInterface* self,
                                gboolean show)
{
	GtkSeparator* _tmp0_;
	GtkSeparator* _tmp1_;
	GtkSeparator* _tmp2_;
	GtkSeparator* _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = network_widget_nm_interface_get_sep ((NetworkWidgetNMInterface*) self);
	_tmp1_ = _tmp0_;
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp1_, !show);
	gtk_widget_set_no_show_all ((GtkWidget*) self, !show);
	_tmp2_ = network_widget_nm_interface_get_sep ((NetworkWidgetNMInterface*) self);
	_tmp3_ = _tmp2_;
	gtk_widget_set_visible ((GtkWidget*) _tmp3_, show);
	gtk_widget_set_visible ((GtkWidget*) self, show);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static gboolean
__lambda22_ (NetworkVpnInterface* self)
{
	gboolean result;
	network_widget_nm_interface_update ((NetworkWidgetNMInterface*) self);
	result = FALSE;
	return result;
}

static gboolean
___lambda22__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda22_ ((NetworkVpnInterface*) self);
	return result;
}

static void
network_vpn_interface_vpn_activate_cb (NetworkVpnInterface* self,
                                       NetworkVpnMenuItem* item)
{
	NMRemoteConnection* _tmp0_;
	NMRemoteConnection* _tmp1_;
	const gchar* _tmp2_;
	NMClient* _tmp3_;
	NMRemoteConnection* _tmp4_;
	NMRemoteConnection* _tmp5_;
	NetworkVpnMenuItem* _tmp6_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (item != NULL);
	g_warning ("VpnInterface.vala:153: Activating connection");
	network_vpn_interface_vpn_deactivate_cb (self);
	_tmp0_ = network_vpn_menu_item_get_connection (item);
	_tmp1_ = _tmp0_;
	_tmp2_ = nm_connection_get_id ((NMConnection*) _tmp1_);
	g_debug ("VpnInterface.vala:156: Connecting to VPN : %s", _tmp2_);
	_tmp3_ = self->priv->_nm_client;
	_tmp4_ = network_vpn_menu_item_get_connection (item);
	_tmp5_ = _tmp4_;
	nm_client_activate_connection_async (_tmp3_, (NMConnection*) _tmp5_, NULL, NULL, NULL, NULL, NULL);
	_tmp6_ = _g_object_ref0 (item);
	_g_object_unref0 (self->priv->active_vpn_item);
	self->priv->active_vpn_item = _tmp6_;
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda22__gsource_func, g_object_ref (self), g_object_unref);
}

static gboolean
__lambda21_ (NetworkVpnInterface* self)
{
	gboolean result;
	network_widget_nm_interface_update ((NetworkWidgetNMInterface*) self);
	result = FALSE;
	return result;
}

static gboolean
___lambda21__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda21_ ((NetworkVpnInterface*) self);
	return result;
}

static void
network_vpn_interface_vpn_deactivate_cb (NetworkVpnInterface* self)
{
	NMVpnConnection* _tmp0_;
	NMVpnConnection* _tmp1_;
	const gchar* _tmp2_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->active_vpn_connection;
	if (_tmp0_ == NULL) {
		network_widget_nm_interface_update ((NetworkWidgetNMInterface*) self);
		return;
	}
	_tmp1_ = self->priv->active_vpn_connection;
	_tmp2_ = nm_active_connection_get_id ((NMActiveConnection*) _tmp1_);
	g_debug ("VpnInterface.vala:168: Deactivating VPN : %s", _tmp2_);
	{
		NMClient* _tmp3_;
		NMVpnConnection* _tmp4_;
		_tmp3_ = self->priv->_nm_client;
		_tmp4_ = self->priv->active_vpn_connection;
		nm_client_deactivate_connection (_tmp3_, (NMActiveConnection*) _tmp4_, NULL, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp5_;
		const gchar* _tmp6_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp5_ = e;
		_tmp6_ = _tmp5_->message;
		g_warning ("VpnInterface.vala:172: %s", _tmp6_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda21__gsource_func, g_object_ref (self), g_object_unref);
}

/**
      * The vpn_added_cb is called on new_connection signal,
      * (we get the vpn connections from there)
      * then we filter the connection that make sense for us.
    */
static void
_network_vpn_interface_vpn_activate_cb_network_vpn_menu_item_user_action (NetworkVpnMenuItem* _sender,
                                                                          gpointer self)
{
	network_vpn_interface_vpn_activate_cb ((NetworkVpnInterface*) self, _sender);
}

static void
network_vpn_interface_vpn_added_cb (NetworkVpnInterface* self,
                                    GObject* obj)
{
	NMRemoteConnection* vpn = NULL;
	NMRemoteConnection* _tmp0_;
	NMRemoteConnection* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	GQuark _tmp5_ = 0U;
	static GQuark _tmp4_label0 = 0;
	g_return_if_fail (self != NULL);
	g_return_if_fail (obj != NULL);
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (obj, nm_remote_connection_get_type (), NMRemoteConnection));
	vpn = _tmp0_;
	_tmp1_ = vpn;
	_tmp2_ = nm_connection_get_connection_type ((NMConnection*) _tmp1_);
	_tmp3_ = _tmp2_;
	_tmp5_ = (NULL == _tmp3_) ? 0 : g_quark_from_string (_tmp3_);
	if (_tmp5_ == ((0 != _tmp4_label0) ? _tmp4_label0 : (_tmp4_label0 = g_quark_from_static_string (NM_SETTING_VPN_SETTING_NAME)))) {
		switch (0) {
			default:
			{
				NetworkVpnMenuItem* item = NULL;
				NetworkVpnMenuItem* _tmp6_;
				NMRemoteConnection* _tmp7_;
				NetworkVpnMenuItem* _tmp8_;
				NetworkVpnMenuItem* _tmp9_;
				NetworkVpnMenuItem* _tmp10_;
				GtkListBox* _tmp11_;
				NetworkVpnMenuItem* _tmp12_;
				_tmp6_ = self->priv->blank_item;
				_tmp7_ = vpn;
				_tmp8_ = network_vpn_menu_item_new (_tmp6_, _tmp7_);
				g_object_ref_sink (_tmp8_);
				item = _tmp8_;
				_tmp9_ = item;
				gtk_widget_set_visible ((GtkWidget*) _tmp9_, TRUE);
				_tmp10_ = item;
				g_signal_connect_object (_tmp10_, "user-action", (GCallback) _network_vpn_interface_vpn_activate_cb_network_vpn_menu_item_user_action, self, 0);
				_tmp11_ = self->priv->vpn_list;
				_tmp12_ = item;
				gtk_container_add ((GtkContainer*) _tmp11_, (GtkWidget*) _tmp12_);
				network_widget_nm_interface_update ((NetworkWidgetNMInterface*) self);
				_g_object_unref0 (item);
				break;
			}
		}
	} else {
		switch (0) {
			default:
			{
				break;
			}
		}
	}
	_g_object_unref0 (vpn);
}

static void
network_vpn_interface_vpn_removed_cb (NetworkVpnInterface* self,
                                      NMRemoteConnection* vpn_)
{
	NetworkVpnMenuItem* item = NULL;
	const gchar* _tmp0_;
	NetworkVpnMenuItem* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (vpn_ != NULL);
	_tmp0_ = nm_connection_get_uuid ((NMConnection*) vpn_);
	_tmp1_ = network_vpn_interface_get_item_by_uuid (self, _tmp0_);
	item = _tmp1_;
	gtk_widget_destroy ((GtkWidget*) item);
	_g_object_unref0 (item);
}

static NetworkVpnMenuItem*
network_vpn_interface_get_item_by_uuid (NetworkVpnInterface* self,
                                        const gchar* uuid)
{
	NetworkVpnMenuItem* item = NULL;
	GtkListBox* _tmp0_;
	GList* _tmp1_;
	NetworkVpnMenuItem* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (uuid != NULL, NULL);
	item = NULL;
	_tmp0_ = self->priv->vpn_list;
	_tmp1_ = gtk_container_get_children ((GtkContainer*) _tmp0_);
	{
		GList* child_collection = NULL;
		GList* child_it = NULL;
		child_collection = _tmp1_;
		for (child_it = child_collection; child_it != NULL; child_it = child_it->next) {
			GtkWidget* child = NULL;
			child = (GtkWidget*) child_it->data;
			{
				NetworkVpnMenuItem* _item = NULL;
				GtkWidget* _tmp2_;
				gboolean _tmp3_ = FALSE;
				gboolean _tmp4_ = FALSE;
				NetworkVpnMenuItem* _tmp5_;
				NMRemoteConnection* _tmp6_;
				NMRemoteConnection* _tmp7_;
				_tmp2_ = child;
				_item = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, NETWORK_TYPE_VPN_MENU_ITEM, NetworkVpnMenuItem);
				_tmp5_ = _item;
				_tmp6_ = network_vpn_menu_item_get_connection (_tmp5_);
				_tmp7_ = _tmp6_;
				if (_tmp7_ != NULL) {
					NetworkVpnMenuItem* _tmp8_;
					NMRemoteConnection* _tmp9_;
					NMRemoteConnection* _tmp10_;
					const gchar* _tmp11_;
					_tmp8_ = _item;
					_tmp9_ = network_vpn_menu_item_get_connection (_tmp8_);
					_tmp10_ = _tmp9_;
					_tmp11_ = nm_connection_get_uuid ((NMConnection*) _tmp10_);
					_tmp4_ = g_strcmp0 (_tmp11_, uuid) == 0;
				} else {
					_tmp4_ = FALSE;
				}
				if (_tmp4_) {
					NetworkVpnMenuItem* _tmp12_;
					_tmp12_ = item;
					_tmp3_ = _tmp12_ == NULL;
				} else {
					_tmp3_ = FALSE;
				}
				if (_tmp3_) {
					GtkWidget* _tmp13_;
					NetworkVpnMenuItem* _tmp14_;
					_tmp13_ = child;
					_tmp14_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, NETWORK_TYPE_VPN_MENU_ITEM, NetworkVpnMenuItem));
					_g_object_unref0 (item);
					item = _tmp14_;
				}
			}
		}
		(child_collection == NULL) ? NULL : (child_collection = (g_list_free (child_collection), NULL));
	}
	result = item;
	return result;
}

/**
     * Loop through each active connection to find out the vpn.
    */
static void
_network_widget_nm_interface_update_nm_vpn_connection_vpn_state_changed (NMVpnConnection* _sender,
                                                                         guint state,
                                                                         guint reason,
                                                                         gpointer self)
{
	network_widget_nm_interface_update ((NetworkWidgetNMInterface*) self);
}

static void
__lambda20_ (NetworkVpnInterface* self,
             NMActiveConnection* ac)
{
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (ac != NULL);
	if (nm_active_connection_get_vpn (ac)) {
		NMVpnConnection* _tmp1_;
		_tmp1_ = self->priv->active_vpn_connection;
		_tmp0_ = _tmp1_ == NULL;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		NMVpnConnection* _tmp2_;
		NMVpnConnection* _tmp3_;
		GtkListBox* _tmp4_;
		GList* _tmp5_;
		_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (ac, nm_vpn_connection_get_type (), NMVpnConnection));
		_g_object_unref0 (self->priv->active_vpn_connection);
		self->priv->active_vpn_connection = _tmp2_;
		_tmp3_ = self->priv->active_vpn_connection;
		g_signal_connect_object (_tmp3_, "vpn-state-changed", (GCallback) _network_widget_nm_interface_update_nm_vpn_connection_vpn_state_changed, (NetworkWidgetNMInterface*) self, 0);
		_tmp4_ = self->priv->vpn_list;
		_tmp5_ = gtk_container_get_children ((GtkContainer*) _tmp4_);
		{
			GList* v_collection = NULL;
			GList* v_it = NULL;
			v_collection = _tmp5_;
			for (v_it = v_collection; v_it != NULL; v_it = v_it->next) {
				GtkWidget* v = NULL;
				v = (GtkWidget*) v_it->data;
				{
					NetworkVpnMenuItem* menu_item = NULL;
					GtkWidget* _tmp6_;
					NetworkVpnMenuItem* _tmp7_;
					NMRemoteConnection* _tmp8_;
					NMRemoteConnection* _tmp9_;
					NetworkVpnMenuItem* _tmp10_;
					NMRemoteConnection* _tmp11_;
					NMRemoteConnection* _tmp12_;
					const gchar* _tmp13_;
					NMVpnConnection* _tmp14_;
					const gchar* _tmp15_;
					const gchar* _tmp16_;
					_tmp6_ = v;
					menu_item = G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, NETWORK_TYPE_VPN_MENU_ITEM, NetworkVpnMenuItem);
					_tmp7_ = menu_item;
					_tmp8_ = network_vpn_menu_item_get_connection (_tmp7_);
					_tmp9_ = _tmp8_;
					if (_tmp9_ == NULL) {
						continue;
					}
					_tmp10_ = menu_item;
					_tmp11_ = network_vpn_menu_item_get_connection (_tmp10_);
					_tmp12_ = _tmp11_;
					_tmp13_ = nm_connection_get_uuid ((NMConnection*) _tmp12_);
					_tmp14_ = self->priv->active_vpn_connection;
					_tmp15_ = nm_active_connection_get_uuid ((NMActiveConnection*) _tmp14_);
					_tmp16_ = _tmp15_;
					if (g_strcmp0 (_tmp13_, _tmp16_) == 0) {
						NetworkVpnMenuItem* _tmp17_;
						NetworkVpnMenuItem* _tmp18_;
						NetworkVpnMenuItem* _tmp19_;
						NetworkVpnMenuItem* _tmp20_;
						NetworkState _tmp21_;
						_tmp17_ = menu_item;
						network_vpn_menu_item_set_active (_tmp17_, TRUE);
						_tmp18_ = menu_item;
						_tmp19_ = _g_object_ref0 (_tmp18_);
						_g_object_unref0 (self->priv->active_vpn_item);
						self->priv->active_vpn_item = _tmp19_;
						_tmp20_ = self->priv->active_vpn_item;
						_tmp21_ = self->priv->_vpn_state;
						network_vpn_menu_item_set_vpn_state (_tmp20_, _tmp21_);
					} else {
						NetworkVpnMenuItem* _tmp22_;
						_tmp22_ = menu_item;
						network_vpn_menu_item_set_active (_tmp22_, FALSE);
					}
				}
			}
			(v_collection == NULL) ? NULL : (v_collection = (g_list_free (v_collection), NULL));
		}
	}
}

static void
___lambda20__gfunc (gconstpointer data,
                    gpointer self)
{
	__lambda20_ ((NetworkVpnInterface*) self, (NMActiveConnection*) data);
}

static void
network_vpn_interface_update_active_connection (NetworkVpnInterface* self)
{
	NMClient* _tmp0_;
	GPtrArray* _tmp1_;
	g_return_if_fail (self != NULL);
	_g_object_unref0 (self->priv->active_vpn_connection);
	self->priv->active_vpn_connection = NULL;
	_tmp0_ = self->priv->_nm_client;
	_tmp1_ = nm_client_get_active_connections (_tmp0_);
	g_ptr_array_foreach (_tmp1_, ___lambda20__gfunc, self);
}

NetworkState
network_vpn_interface_get_vpn_state (NetworkVpnInterface* self)
{
	NetworkState result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_vpn_state;
	return result;
}

static void
network_vpn_interface_set_vpn_state (NetworkVpnInterface* self,
                                     NetworkState value)
{
	NetworkState old_value;
	g_return_if_fail (self != NULL);
	old_value = network_vpn_interface_get_vpn_state (self);
	if (old_value != value) {
		self->priv->_vpn_state = value;
		g_object_notify_by_pspec ((GObject *) self, network_vpn_interface_properties[NETWORK_VPN_INTERFACE_VPN_STATE_PROPERTY]);
	}
}

NMClient*
network_vpn_interface_get_nm_client (NetworkVpnInterface* self)
{
	NMClient* result;
	NMClient* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_nm_client;
	result = _tmp0_;
	return result;
}

static void
network_vpn_interface_set_nm_client (NetworkVpnInterface* self,
                                     NMClient* value)
{
	NMClient* old_value;
	g_return_if_fail (self != NULL);
	old_value = network_vpn_interface_get_nm_client (self);
	if (old_value != value) {
		NMClient* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_nm_client);
		self->priv->_nm_client = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, network_vpn_interface_properties[NETWORK_VPN_INTERFACE_NM_CLIENT_PROPERTY]);
	}
}

static void
_network_vpn_interface___lambda23_ (NetworkVpnInterface* self)
{
	GtkRevealer* _tmp0_;
	GraniteSwitchModelButton* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	GraniteSwitchModelButton* _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_;
	_tmp0_ = self->priv->revealer;
	_tmp1_ = self->priv->vpn_item;
	_tmp2_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp1_);
	_tmp3_ = _tmp2_;
	gtk_revealer_set_reveal_child (_tmp0_, _tmp3_);
	_tmp4_ = self->priv->vpn_item;
	_tmp5_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp4_);
	_tmp6_ = _tmp5_;
	if (!_tmp6_) {
		network_vpn_interface_vpn_deactivate_cb (self);
	}
}

static void
__network_vpn_interface___lambda23__g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self)
{
	_network_vpn_interface___lambda23_ ((NetworkVpnInterface*) self);
}

static void
_network_widget_nm_interface_update_g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self)
{
	network_widget_nm_interface_update ((NetworkWidgetNMInterface*) self);
}

static void
_network_vpn_interface_check_vpn_availability_gtk_container_add (GtkContainer* _sender,
                                                                 GtkWidget* widget,
                                                                 gpointer self)
{
	network_vpn_interface_check_vpn_availability ((NetworkVpnInterface*) self);
}

static void
_network_vpn_interface_check_vpn_availability_gtk_container_remove (GtkContainer* _sender,
                                                                    GtkWidget* widget,
                                                                    gpointer self)
{
	network_vpn_interface_check_vpn_availability ((NetworkVpnInterface*) self);
}

static void
_network_vpn_interface_vpn_added_cb_nm_client_connection_added (NMClient* _sender,
                                                                NMRemoteConnection* connection,
                                                                gpointer self)
{
	network_vpn_interface_vpn_added_cb ((NetworkVpnInterface*) self, connection);
}

static void
_network_vpn_interface_vpn_removed_cb_nm_client_connection_removed (NMClient* _sender,
                                                                    NMRemoteConnection* connection,
                                                                    gpointer self)
{
	network_vpn_interface_vpn_removed_cb ((NetworkVpnInterface*) self, connection);
}

static void
_network_vpn_interface___lambda24_ (NetworkVpnInterface* self,
                                    NMRemoteConnection* connection)
{
	g_return_if_fail (connection != NULL);
	network_vpn_interface_vpn_added_cb (self, (GObject*) connection);
}

static void
__network_vpn_interface___lambda24__gfunc (gconstpointer data,
                                           gpointer self)
{
	_network_vpn_interface___lambda24_ ((NetworkVpnInterface*) self, (NMRemoteConnection*) data);
}

static GObject *
network_vpn_interface_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	NetworkVpnInterface * self;
	NetworkVpnMenuItem* _tmp0_;
	NetworkVpnMenuItem* _tmp1_;
	GtkListBox* _tmp2_ = NULL;
	GtkListBox* _tmp3_;
	NetworkVpnMenuItem* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	GraniteSwitchModelButton* _tmp7_;
	GraniteSwitchModelButton* _tmp8_;
	GtkStyleContext* _tmp9_;
	GtkScrolledWindow* scrolled_box = NULL;
	GtkScrolledWindow* _tmp10_;
	GtkScrolledWindow* _tmp11_;
	GtkScrolledWindow* _tmp12_;
	GtkScrolledWindow* _tmp13_;
	GtkScrolledWindow* _tmp14_;
	GtkListBox* _tmp15_;
	GtkRevealer* _tmp16_;
	GtkRevealer* _tmp17_;
	GtkScrolledWindow* _tmp18_;
	GraniteSwitchModelButton* _tmp19_;
	GtkRevealer* _tmp20_;
	GraniteSwitchModelButton* _tmp21_;
	GtkListBox* _tmp22_;
	GtkListBox* _tmp23_;
	NMClient* _tmp24_;
	NMClient* _tmp25_;
	NMClient* _tmp26_;
	NMClient* _tmp27_;
	GPtrArray* _tmp28_;
	parent_class = G_OBJECT_CLASS (network_vpn_interface_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NETWORK_TYPE_VPN_INTERFACE, NetworkVpnInterface);
	_g_object_unref0 (self->priv->active_vpn_item);
	self->priv->active_vpn_item = NULL;
	network_widget_nm_interface_set_display_title ((NetworkWidgetNMInterface*) self, _ ("VPN"));
	_tmp0_ = network_vpn_menu_item_new (NULL, NULL);
	g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->priv->blank_item);
	self->priv->blank_item = _tmp0_;
	_tmp1_ = self->priv->blank_item;
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp1_, TRUE);
	_tmp2_ = (GtkListBox*) gtk_list_box_new ();
	gtk_list_box_set_activate_on_single_click (_tmp2_, FALSE);
	gtk_widget_set_visible ((GtkWidget*) _tmp2_, TRUE);
	g_object_ref_sink (_tmp2_);
	_g_object_unref0 (self->priv->vpn_list);
	self->priv->vpn_list = _tmp2_;
	_tmp3_ = self->priv->vpn_list;
	_tmp4_ = self->priv->blank_item;
	gtk_container_add ((GtkContainer*) _tmp3_, (GtkWidget*) _tmp4_);
	_tmp5_ = network_widget_nm_interface_get_display_title ((NetworkWidgetNMInterface*) self);
	_tmp6_ = _tmp5_;
	_tmp7_ = granite_switch_model_button_new (_tmp6_);
	g_object_ref_sink (_tmp7_);
	_g_object_unref0 (self->priv->vpn_item);
	self->priv->vpn_item = _tmp7_;
	_tmp8_ = self->priv->vpn_item;
	_tmp9_ = gtk_widget_get_style_context ((GtkWidget*) _tmp8_);
	gtk_style_context_add_class (_tmp9_, GRANITE_STYLE_CLASS_H4_LABEL);
	_tmp10_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
	g_object_ref_sink (_tmp10_);
	scrolled_box = _tmp10_;
	_tmp11_ = scrolled_box;
	g_object_set (_tmp11_, "hscrollbar-policy", GTK_POLICY_NEVER, NULL);
	_tmp12_ = scrolled_box;
	gtk_scrolled_window_set_max_content_height (_tmp12_, 512);
	_tmp13_ = scrolled_box;
	gtk_scrolled_window_set_propagate_natural_height (_tmp13_, TRUE);
	_tmp14_ = scrolled_box;
	_tmp15_ = self->priv->vpn_list;
	gtk_container_add ((GtkContainer*) _tmp14_, (GtkWidget*) _tmp15_);
	_tmp16_ = (GtkRevealer*) gtk_revealer_new ();
	g_object_ref_sink (_tmp16_);
	_g_object_unref0 (self->priv->revealer);
	self->priv->revealer = _tmp16_;
	_tmp17_ = self->priv->revealer;
	_tmp18_ = scrolled_box;
	gtk_container_add ((GtkContainer*) _tmp17_, (GtkWidget*) _tmp18_);
	gtk_orientable_set_orientation ((GtkOrientable*) self, GTK_ORIENTATION_VERTICAL);
	_tmp19_ = self->priv->vpn_item;
	gtk_box_pack_start ((GtkBox*) self, (GtkWidget*) _tmp19_, TRUE, TRUE, (guint) 0);
	_tmp20_ = self->priv->revealer;
	gtk_box_pack_start ((GtkBox*) self, (GtkWidget*) _tmp20_, TRUE, TRUE, (guint) 0);
	_tmp21_ = self->priv->vpn_item;
	g_signal_connect_object ((GObject*) _tmp21_, "notify::active", (GCallback) __network_vpn_interface___lambda23__g_object_notify, self, 0);
	network_widget_nm_interface_update ((NetworkWidgetNMInterface*) self);
	g_signal_connect_object ((GObject*) self, "notify::vpn-state", (GCallback) _network_widget_nm_interface_update_g_object_notify, (NetworkWidgetNMInterface*) self, 0);
	_tmp22_ = self->priv->vpn_list;
	g_signal_connect_object ((GtkContainer*) _tmp22_, "add", (GCallback) _network_vpn_interface_check_vpn_availability_gtk_container_add, self, 0);
	_tmp23_ = self->priv->vpn_list;
	g_signal_connect_object ((GtkContainer*) _tmp23_, "remove", (GCallback) _network_vpn_interface_check_vpn_availability_gtk_container_remove, self, 0);
	_tmp24_ = self->priv->_nm_client;
	g_signal_connect_object ((GObject*) _tmp24_, "notify::active-connections", (GCallback) _network_widget_nm_interface_update_g_object_notify, (NetworkWidgetNMInterface*) self, 0);
	_tmp25_ = self->priv->_nm_client;
	g_signal_connect_object (_tmp25_, "connection-added", (GCallback) _network_vpn_interface_vpn_added_cb_nm_client_connection_added, self, 0);
	_tmp26_ = self->priv->_nm_client;
	g_signal_connect_object (_tmp26_, "connection-removed", (GCallback) _network_vpn_interface_vpn_removed_cb_nm_client_connection_removed, self, 0);
	_tmp27_ = self->priv->_nm_client;
	_tmp28_ = nm_client_get_connections (_tmp27_);
	g_ptr_array_foreach (_tmp28_, __network_vpn_interface___lambda24__gfunc, self);
	_g_object_unref0 (scrolled_box);
	return obj;
}

static void
network_vpn_interface_class_init (NetworkVpnInterfaceClass * klass,
                                  gpointer klass_data)
{
	network_vpn_interface_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &NetworkVpnInterface_private_offset);
	((NetworkWidgetNMInterfaceClass *) klass)->update_name = (void (*) (NetworkWidgetNMInterface*, gint)) network_vpn_interface_real_update_name;
	((NetworkWidgetNMInterfaceClass *) klass)->update = (void (*) (NetworkWidgetNMInterface*)) network_vpn_interface_real_update;
	G_OBJECT_CLASS (klass)->get_property = _vala_network_vpn_interface_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_network_vpn_interface_set_property;
	G_OBJECT_CLASS (klass)->constructor = network_vpn_interface_constructor;
	G_OBJECT_CLASS (klass)->finalize = network_vpn_interface_finalize;
	/**
	     * If we want to add a visual feedback on DisplayWidget later,
	     * we just need to remove vpn_state and swap it to state on the code
	    **/
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_VPN_INTERFACE_VPN_STATE_PROPERTY, network_vpn_interface_properties[NETWORK_VPN_INTERFACE_VPN_STATE_PROPERTY] = g_param_spec_enum ("vpn-state", "vpn-state", "vpn-state", NETWORK_TYPE_STATE, NETWORK_STATE_DISCONNECTED, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_VPN_INTERFACE_NM_CLIENT_PROPERTY, network_vpn_interface_properties[NETWORK_VPN_INTERFACE_NM_CLIENT_PROPERTY] = g_param_spec_object ("nm-client", "nm-client", "nm-client", nm_client_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}

static void
network_vpn_interface_instance_init (NetworkVpnInterface * self,
                                     gpointer klass)
{
	self->priv = network_vpn_interface_get_instance_private (self);
	self->priv->_vpn_state = NETWORK_STATE_DISCONNECTED;
	self->priv->active_vpn_connection = NULL;
	self->priv->blank_item = NULL;
}

static void
network_vpn_interface_finalize (GObject * obj)
{
	NetworkVpnInterface * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NETWORK_TYPE_VPN_INTERFACE, NetworkVpnInterface);
	_g_object_unref0 (self->priv->_nm_client);
	_g_object_unref0 (self->priv->active_vpn_connection);
	_g_object_unref0 (self->priv->vpn_list);
	_g_object_unref0 (self->priv->active_vpn_item);
	_g_object_unref0 (self->priv->blank_item);
	_g_object_unref0 (self->priv->vpn_item);
	_g_object_unref0 (self->priv->revealer);
	G_OBJECT_CLASS (network_vpn_interface_parent_class)->finalize (obj);
}

static GType
network_vpn_interface_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (NetworkVpnInterfaceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) network_vpn_interface_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NetworkVpnInterface), 0, (GInstanceInitFunc) network_vpn_interface_instance_init, NULL };
	GType network_vpn_interface_type_id;
	network_vpn_interface_type_id = g_type_register_static (NETWORK_TYPE_WIDGET_NM_INTERFACE, "NetworkVpnInterface", &g_define_type_info, 0);
	NetworkVpnInterface_private_offset = g_type_add_instance_private (network_vpn_interface_type_id, sizeof (NetworkVpnInterfacePrivate));
	return network_vpn_interface_type_id;
}

GType
network_vpn_interface_get_type (void)
{
	static volatile gsize network_vpn_interface_type_id__once = 0;
	if (g_once_init_enter (&network_vpn_interface_type_id__once)) {
		GType network_vpn_interface_type_id;
		network_vpn_interface_type_id = network_vpn_interface_get_type_once ();
		g_once_init_leave (&network_vpn_interface_type_id__once, network_vpn_interface_type_id);
	}
	return network_vpn_interface_type_id__once;
}

static void
_vala_network_vpn_interface_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec)
{
	NetworkVpnInterface * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NETWORK_TYPE_VPN_INTERFACE, NetworkVpnInterface);
	switch (property_id) {
		case NETWORK_VPN_INTERFACE_VPN_STATE_PROPERTY:
		g_value_set_enum (value, network_vpn_interface_get_vpn_state (self));
		break;
		case NETWORK_VPN_INTERFACE_NM_CLIENT_PROPERTY:
		g_value_set_object (value, network_vpn_interface_get_nm_client (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_network_vpn_interface_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec)
{
	NetworkVpnInterface * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NETWORK_TYPE_VPN_INTERFACE, NetworkVpnInterface);
	switch (property_id) {
		case NETWORK_VPN_INTERFACE_VPN_STATE_PROPERTY:
		network_vpn_interface_set_vpn_state (self, g_value_get_enum (value));
		break;
		case NETWORK_VPN_INTERFACE_NM_CLIENT_PROPERTY:
		network_vpn_interface_set_nm_client (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

